#include <cstdio>
#include <map>
#include <vector>

using namespace std;

int recolorings[24][6] = {
{ 0, 1, 2, 3, 4, 5, }, 
{ 0, 2, 3, 5, 4, 1, }, 
{ 0, 3, 5, 1, 4, 2, }, 
{ 0, 5, 1, 2, 4, 3, }, 
{ 1, 0, 5, 4, 3, 2, }, 
{ 1, 2, 0, 5, 3, 4, }, 
{ 1, 4, 2, 0, 3, 5, }, 
{ 1, 5, 4, 2, 3, 0, }, 
{ 2, 0, 1, 4, 5, 3, }, 
{ 2, 1, 4, 3, 5, 0, }, 
{ 2, 3, 0, 1, 5, 4, }, 
{ 2, 4, 3, 0, 5, 1, }, 
{ 3, 0, 2, 4, 1, 5, }, 
{ 3, 2, 4, 5, 1, 0, }, 
{ 3, 4, 5, 0, 1, 2, }, 
{ 3, 5, 0, 2, 1, 4, }, 
{ 4, 1, 5, 3, 0, 2, }, 
{ 4, 2, 1, 5, 0, 3, }, 
{ 4, 3, 2, 1, 0, 5, }, 
{ 4, 5, 3, 2, 0, 1, }, 
{ 5, 0, 3, 4, 2, 1, }, 
{ 5, 1, 0, 3, 2, 4, }, 
{ 5, 3, 4, 1, 2, 0, }, 
{ 5, 4, 1, 0, 2, 3, }
};

int cycles[8][6] = {
{ 1, 3, 5, 9, 8, 4 },
{ 2, 3, 5, 10, 11, 6 },
{ 13, 8, 9, 14, 16, 17 },
{ 18, 16, 14, 10, 11, 15 },
{ 15, 12, 22, 20, 19, 18 },
{ 7, 13, 17, 19, 20, 21 },
{ 6, 12, 22, 23, 0, 2 },
{ 7, 4, 1, 0, 23, 21 }
};

map<vector<char>,int> dist;

void rotate(int indexes[], vector<char> &tab)
{
	int len = 6;
	int tmp = tab[indexes[0]];
	for (int i = 1; i<len; i++)
		tab[indexes[i-1]] = tab[indexes[i]];
	tab[indexes[len-1]]= tmp;
}

int find_dist(vector<char> &v)
{
	vector<char> w = v;
	for (int i = 0; i < 24; i++) {
		for (int j = 0; j < 24; j++)
			w[j] = recolorings[i][v[j]];
		int d = dist[w];
		if (d != 0)
			return d;
	}
	return 0;
}
#define MAX_D 5

void bfs(int d, vector <vector <char> > &q)
{
	vector <vector <char > >  res;
	//printf("%d %d\n",d,q.size());
	if (d > MAX_D) return;
	for (int i = 0; i < q.size(); i++) {
		for (int j = 0; j < 8; j++) {
			for (int k = 0; k < 2; k++) {
				vector<char> t = q[i];
				rotate(cycles[j], t);
				rotate(cycles[j], t);
			//	for(int qq=0;qq<24;qq++)
			//		printf("%d ", t[qq]);
			//	printf("\n");
				if (!find_dist (t)) {
					res.push_back(t);
					dist[t] = d+1;
				}
			}
			
		}
	}
	if (res.size()>0)
	bfs(d+1,res);
}

void read()
{
	vector <char> v;
	for(int i=0;i<24;i++) {
		int x;
		scanf("%d",&x);
		v.push_back(x);
	}
	int d= find_dist(v);
	if (d == 0)
		abort();
	printf("%d\n", d - 1);
}

int main()
{
	vector<char> init;
	init.push_back(0);
	init.push_back(0);
	init.push_back(0);
	init.push_back(0);
	init.push_back(1);
	init.push_back(2);
	init.push_back(3);
	init.push_back(1);
	init.push_back(1);
	init.push_back(2);
	init.push_back(2);
	init.push_back(3);
	init.push_back(3);
	init.push_back(1);
	init.push_back(2);
	init.push_back(3);
	init.push_back(4);
	init.push_back(4);
	init.push_back(4);
	init.push_back(4);
	init.push_back(5);
	init.push_back(5);
	init.push_back(5);
	init.push_back(5);

	vector<vector <char> > q;
	q.push_back(init);
	dist[init] = 1;
	bfs(1, q);

	int n;scanf("%d",&n);
	while (n--)
		read();
	return 0;
}

/* vim: ai
*/
