#include<cstdio>
#include<utility>
#include<vector>
#include<algorithm>
using namespace std;
int n;
typedef pair<int,int> zolnierz;
zolnierz pluton[2][500];
float dist[500][500];
typedef pair<float,pair<int,int> >ed;
vector<ed> eds;

typedef int flowt;
struct edge{
    int dest;
    flowt capacity;
    edge(int dest,flowt capacity):dest(dest),capacity(capacity){};
};
struct node{
    vector<int> edges;
    int frozen;
};
const int MAX_NODES=500*500+500;
const flowt infinity=1000000000;
node nodes[MAX_NODES];
vector<edge> edges;
int round;
int sink;
void add_edge(int from,int to,flowt capacity){
    nodes[from].edges.push_back(edges.size());
    edges.push_back(edge(to,capacity));
    nodes[to].edges.push_back(edges.size());
    edges.push_back(edge(from,0));
}
void clear(){
    for(int i=0;i<MAX_NODES;i++)
	nodes[i].edges.clear();
    edges.clear();
}
flowt find_some(int from,flowt limit){
    node & n=nodes[from];
    if(!limit || n.frozen==round)
	return 0;
    if(from==sink)
	return limit;
    n.frozen=round;
    flowt done=0;
    for(int i=n.edges.size();limit && i--;){
	int e=n.edges[i];
	if(flowt flow=find_some(edges[e].dest,limit<?edges[e].capacity)){
	    edges[e].capacity-=flow;
	    edges[e^1].capacity+=flow;
	    done+=flow;
	    limit-=flow;
	}
    }
    return done;
}
float odl(zolnierz a,zolnierz b){
    float dx= (a.first-b.first);
    float dy= (a.second-b.second);
    return dx*dx+dy*dy;
}
void test(int m){
//printf("Testing %d\n",m);
    clear();
    for(int e=0;e<m;e++)
	add_edge(
	1+eds[e].second.first,
	1+n+eds[e].second.second,
	1
	);
    for(int i=0;i<n;i++){
	add_edge(0,1+i,1);
	add_edge(1+n+i,1+n+n,1);
    }
}
flowt max_flow(int from, int to){
    flowt result=0;
    sink=to;
    for(int i=0;i<MAX_NODES;i++){
	nodes[i].frozen=0;
    }
    for(round=1;flowt flow=find_some(from,infinity);round++)
	result+=flow;
    return result;
}
void solve(){
    scanf("%d",&n);
    clear();
    for(int p=0;p<2;p++)
	for(int i=0;i<n;i++){
	    int x,y;
	    scanf("%d %d",&x,&y);
	    pluton[p][i]=make_pair(x,y);
	}
    eds.clear();
    for(int i=0;i<n;i++)
	for(int j=0;j<n;j++){
	    dist[i][j]= odl(pluton[0][i],pluton[1][j]);
	    eds.push_back(make_pair(dist[i][j], make_pair(i,j)));
	}
    sort(eds.begin(),eds.end());
    int plutonA=1;
    int plutonB=plutonA+n;
    int skojarzonyAB[n];
    int skojarzonyBA[n];
    int a=0;
    int b=eds.size();
    int sink=plutonB+n;    
    while(a+1!=b){
	int m=(a+b)/2;
	test(m);
	if(max_flow(0,sink)==n){
	    b=m;
	}else{
	    a=m+1;
	}
    }
    test(a);
    max_flow(0,sink);
    for(int i=0;i<n;i++){
	int za=plutonA+i;
	for(int e=0;e<nodes[za].edges.size();e++){		    
	    if(edges[nodes[za].edges[e]].capacity<1){
		int zb=edges[nodes[za].edges[e]].dest-plutonB;
		if(zb>=0 && zb<n){
		    skojarzonyAB[i]=zb;	    
		    skojarzonyBA[zb]=i;
		}
	    }
	}
    }

    for(int i=0;i<n;i++){
	printf("%d ",skojarzonyAB[i]+1);
    }
    printf("\n");
    for(int i=0;i<n;i++){
	printf("%d ",skojarzonyBA[i]+1);
    }
    printf("\n");
}
int main(){
    int t;
    scanf("%d",&t);
    while(t--)
	solve();
    return 0;
}

