#include <cstdio>
#include <vector>
#include <queue>

using namespace std;

#define MAX 60000
#define MAX_M 1100000
#define INF 2000000000

typedef pair<int,int> p2;

struct Edge {
  int v,w,t,a,l;
} edge[MAX_M];

vector<int> s[MAX];
int n,m,best[MAX];
bool found[MAX];

struct Vertex {
  int d;
  unsigned short int x;
  bool operator<(const Vertex &v) const {
    return d>v.d;
  }
  Vertex(int d,int x): d(d),x(x) {}
};

priority_queue<Vertex> q;

void check_path(int x,int t) {
//printf("%d %d\n",x,t);
  if (t<best[x]) {
    best[x]=t;
    q.push(Vertex(t,x));
  }
}

void process(int x) {
//printf("process: %d %d\n",x,best[x]);
  int i,t=best[x],tt;
  found[x]=true;
  for (i=0; i<s[x].size(); i++) {
    Edge &e=edge[s[x][i]];
//    printf("%d\n",e.v);
    tt=t;
//    if (tt<e.a)
//      tt=e.a;
    if (e.t+e.a+e.l==0)
      check_path(e.v,tt+e.w);
    else
      if (e.t) {
        if ((e.t+tt-e.a)%e.t>=e.l)
	  tt+=e.t-(e.t+tt-e.a)%e.t;
	check_path(e.v,tt+e.w);
      }
      else
        if (tt<e.a+e.l)
	  check_path(e.v,tt+e.w);
  }
}

int main() {
  int d,i,j;
  
  scanf("%d",&d);
  while (d--) {
    scanf("%d %d",&n,&m);
    for (i=0; i<m; i++) {
      scanf("%d %d %d %d %d %d",&j,&edge[i].v,&edge[i].w,&edge[i].t,&edge[i].a,&edge[i].l);
      s[j].push_back(i);
    }
    for (i=1; i<=n; i++) {
      found[i]=false;
      best[i]=INF;
    }
    while (!q.empty())
      q.pop();
    best[1]=0;
    q.push(Vertex(0,1));
    while (!found[n] && !q.empty()) {
      j=q.top().x;
      q.pop();
      process(j);
    }
    
    if (!found[n])
      printf("NIE\n");
    else
      printf("%d\n",best[n]);
    for (i=1; i<=n; i++)
      s[i].clear();
  }

  return 0;
}
